wx-infra(){
    wx-login
    wx-auto &> /dev/null

    wx-header "Infra"
    wx-restricted

    case $USERNAME in
        cwchristerw)
            if [[ -d "$HOME/Desktop/Work in Progress/Programming/warengroup/infra" ]]
            then
                INFRA_PATH="$HOME/Desktop/Work in Progress/Programming/warengroup/infra"
            else
                if [[ -d "$HOME/.warengroup/infra" ]]
                then
                    INFRA_PATH="$HOME/.warengroup/infra"
                else
                    INFRA_PATH="$HOME/.warengroup/infra"
                    mkdir -p "$INFRA_PATH" &> /dev/null
                    git clone ssh://git@git.waren.io:2222/warengroup-private/infra.git --config core.sshCommand="ssh -i $HOME/.ssh/keys/warengroup-legacy -o ProxyJump=none" "$INFRA_PATH" &> /dev/null
                fi
            fi

            if [[ ! -f "$INFRA_PATH/vault/cwchristerw" || ! -f "$INFRA_PATH/vault/warengroup" ]]
            then
                mkdir -p "$INFRA_PATH/vault" &> /dev/null

                curl \
                    -H "X-Vault-Token: ${config["login",$ORG]}" \
                    -X GET \
                    https://$VAULT_DOMAIN/v1/cli/data/cwchristerw/settings/infra -s | jq -r '.data.data.cwchristerw' > "$INFRA_PATH/vault/cwchristerw"

                curl \
                    -H "X-Vault-Token: ${config["login",$ORG]}" \
                    -X GET \
                    https://$VAULT_DOMAIN/v1/cli/data/cwchristerw/settings/infra -s | jq -r '.data.data.warengroup' > "$INFRA_PATH/vault/warengroup"
            fi

            if [[ -z $1 ]]
            then
                echo "Tag Required"
            else
                if [[ $1 == "init" ]]
                then
                    if [[ -z $2 ]]
                    then
                        echo "Tag Required"
                    else
                        cd "$INFRA_PATH"
                        git pull &> /dev/null
                        ansible-playbook --vault-id warengroup@vault/warengroup --vault-id cwchristerw@vault/cwchristerw playbooks/init.yml -t $2 $3 $4 $5 $6 $7 $8 $9
                        cd "$OLDPWD"
                    fi
                else
                    cd "$INFRA_PATH"
                    git pull &> /dev/null
                    ansible-playbook --vault-id warengroup@vault/warengroup --vault-id cwchristerw@vault/cwchristerw playbooks.yml -t $1 $2 $3 $4 $5 $6 $7 $8 $9
                    cd "$OLDPWD"
                fi
            fi
            ;;
        *)
            echo "User Unsupported"
            ;;
    esac
}
